package dev.fyloz.colorrecipesexplorer.config.properties

import org.springframework.boot.context.properties.ConfigurationProperties
import kotlin.properties.Delegates.notNull

const val DEFAULT_DATA_DIRECTORY = "data"
const val DEFAULT_CONFIG_DIRECTORY = "config"

@ConfigurationProperties(prefix = "cre.server")
class CreProperties {
    var dataDirectory: String = DEFAULT_DATA_DIRECTORY
    var configDirectory: String = DEFAULT_CONFIG_DIRECTORY
}

@ConfigurationProperties(prefix = "cre.security")
class CreSecurityProperties {
    // JWT
    var jwtSecret by notNull<String>()
    var jwtDuration by notNull<Long>()

    // Configs
    var configSalt: String? = null

    // Users
    var root: SystemUserCredentials? = null

    class SystemUserCredentials{
        var id by notNull<Long>()
        var password by notNull<String>()
    }
}
